﻿* Encoding: UTF-8.
*SPSS Syntax for calculating matching probabilites for the LISS ambiguity dataset of Dimmock, Kouwenberg and Wakker (2016).
*Created by Roy Kouwenberg, 28 March 2017. 
*

*Compute lower (_l) and upper (_h) bounds on the matching probability, based on the responses in 6 rounds
*Q0: data for practice ambiguity question with 5 ball colors (20%). No real incentives for practice question. 

COMPUTE Q0_1_l = 0.
COMPUTE Q0_1_h =100.

COMPUTE Q0_2_l = Q0_1_v*(Q0_1_b=2  | Q0_1_b=3) + Q0_1_l*(Q0_1_b=1).
COMPUTE Q0_2_h = Q0_1_v*(Q0_1_b=1  | Q0_1_b=3) + Q0_1_h*(Q0_1_b=2).

COMPUTE Q0_3_l = Q0_2_v*(Q0_2_b=2  | Q0_2_b=3) + Q0_2_l*(Q0_2_b=1).
COMPUTE Q0_3_h = Q0_2_v*(Q0_2_b=1  | Q0_2_b=3) + Q0_2_h*(Q0_2_b=2).

COMPUTE Q0_4_l = Q0_3_v*(Q0_3_b=2  | Q0_3_b=3) + Q0_3_l*(Q0_3_b=1).
COMPUTE Q0_4_h = Q0_3_v*(Q0_3_b=1  | Q0_3_b=3) + Q0_3_h*(Q0_3_b=2).

COMPUTE Q0_5_l = Q0_4_v*(Q0_4_b=2  | Q0_4_b=3) + Q0_4_l*(Q0_4_b=1).
COMPUTE Q0_5_h = Q0_4_v*(Q0_4_b=1  | Q0_4_b=3) + Q0_4_h*(Q0_4_b=2).

COMPUTE Q0_6_l = Q0_5_v*(Q0_5_b=2  | Q0_5_b=3) + Q0_5_l*(Q0_5_b=1).
COMPUTE Q0_6_h = Q0_5_v*(Q0_5_b=1  | Q0_5_b=3) + Q0_5_h*(Q0_5_b=2).

COMPUTE Q0_7_l = Q0_6_v*(Q0_6_b=2  | Q0_6_b=3) + Q0_6_l*(Q0_6_b=1).
COMPUTE Q0_7_h = Q0_6_v*(Q0_6_b=1  | Q0_6_b=3) + Q0_6_h*(Q0_6_b=2).

COMPUTE Q0_l_max = max(Q0_1_l,Q0_2_l,Q0_3_l,Q0_4_l,Q0_5_l,Q0_6_l,Q0_7_l).
COMPUTE Q0_h_min = min(Q0_1_h,Q0_2_h,Q0_3_h,Q0_4_h,Q0_5_h,Q0_6_h,Q0_7_h).

*The matching probability for 20% practice ambiguity question (5 ball colors).
COMPUTE Q0_est = (Q0_l_max + Q0_h_min)/2.

*The ambiguity aversion index for 20% practice ambiguity question (5 ball colors).
COMPUTE Q0_AA = 20 - Q0_est.


*Compute lower (_l) and upper (_h) bounds on the matching probability, based on the responses in 6 rounds
*Q1: data for ambiguity question with 2 ball colors (50%). 

COMPUTE Q1_1_l =0.
COMPUTE Q1_1_h =100.

COMPUTE Q1_2_l = Q1_1_v*(Q1_1_b=2  | Q1_1_b=3) + Q1_1_l*(Q1_1_b=1).
COMPUTE Q1_2_h = Q1_1_v*(Q1_1_b=1  | Q1_1_b=3) + Q1_1_h*(Q1_1_b=2).

COMPUTE Q1_3_l = Q1_2_v*(Q1_2_b=2  | Q1_2_b=3) + Q1_2_l*(Q1_2_b=1).
COMPUTE Q1_3_h = Q1_2_v*(Q1_2_b=1  | Q1_2_b=3) + Q1_2_h*(Q1_2_b=2).

COMPUTE Q1_4_l = Q1_3_v*(Q1_3_b=2  | Q1_3_b=3) + Q1_3_l*(Q1_3_b=1).
COMPUTE Q1_4_h = Q1_3_v*(Q1_3_b=1  | Q1_3_b=3) + Q1_3_h*(Q1_3_b=2).

COMPUTE Q1_5_l = Q1_4_v*(Q1_4_b=2  | Q1_4_b=3) + Q1_4_l*(Q1_4_b=1).
COMPUTE Q1_5_h = Q1_4_v*(Q1_4_b=1  | Q1_4_b=3) + Q1_4_h*(Q1_4_b=2).

COMPUTE Q1_6_l = Q1_5_v*(Q1_5_b=2  | Q1_5_b=3) + Q1_5_l*(Q1_5_b=1).
COMPUTE Q1_6_h = Q1_5_v*(Q1_5_b=1  | Q1_5_b=3) + Q1_5_h*(Q1_5_b=2).

COMPUTE Q1_l_max =  max(Q1_1_l,Q1_2_l,Q1_3_l,Q1_4_l,Q1_5_l,Q1_6_l).
COMPUTE Q1_h_min = min(Q1_1_h,Q1_2_h,Q1_3_h,Q1_4_h,Q1_5_h,Q1_6_h).

*The matching probability for the 50% ambiguity question (2 ball colors).
COMPUTE Q1_est = (Q1_l_max + Q1_h_min)/2.

*The ambiguity aversion index for the 50% ambiguity question (2 ball colors).
COMPUTE Q1_AA = 50 - Q1_est.


*Compute lower (_l) and upper (_h) bounds on the matching probability, based on the responses in 6 rounds
*Q2: data for ambiguity question with 10 ball colors and win for 1 (10%). 

COMPUTE Q2_1_l = 0.
COMPUTE Q2_1_h = 100.

COMPUTE Q2_2_l = Q2_1_v*(Q2_1_b=2  | Q2_1_b=3) + Q2_1_l*(Q2_1_b=1).
COMPUTE Q2_2_h = Q2_1_v*(Q2_1_b=1  | Q2_1_b=3) + Q2_1_h*(Q2_1_b=2).

COMPUTE Q2_3_l = Q2_2_v*(Q2_2_b=2  | Q2_2_b=3) + Q2_2_l*(Q2_2_b=1).
COMPUTE Q2_3_h = Q2_2_v*(Q2_2_b=1  | Q2_2_b=3) + Q2_2_h*(Q2_2_b=2).

COMPUTE Q2_4_l = Q2_3_v*(Q2_3_b=2  | Q2_3_b=3) + Q2_3_l*(Q2_3_b=1).
COMPUTE Q2_4_h = Q2_3_v*(Q2_3_b=1  | Q2_3_b=3) + Q2_3_h*(Q2_3_b=2).

COMPUTE Q2_5_l = Q2_4_v*(Q2_4_b=2  | Q2_4_b=3) + Q2_4_l*(Q2_4_b=1).
COMPUTE Q2_5_h = Q2_4_v*(Q2_4_b=1  | Q2_4_b=3) + Q2_4_h*(Q2_4_b=2).

COMPUTE Q2_6_l = Q2_5_v*(Q2_5_b=2  | Q2_5_b=3) + Q2_5_l*(Q2_5_b=1).
COMPUTE Q2_6_h = Q2_5_v*(Q2_5_b=1  | Q2_5_b=3) + Q2_5_h*(Q2_5_b=2).

COMPUTE Q2_7_l = Q2_6_v*(Q2_6_b=2  | Q2_6_b=3) + Q2_6_l*(Q2_6_b=1).
COMPUTE Q2_7_h = Q2_6_v*(Q2_6_b=1  | Q2_6_b=3) + Q2_6_h*(Q2_6_b=2).

COMPUTE Q2_l_max = max(Q2_1_l,Q2_2_l,Q2_3_l,Q2_4_l,Q2_5_l,Q2_6_l,Q2_7_l).
COMPUTE Q2_h_min = min(Q2_1_h,Q2_2_h,Q2_3_h,Q2_4_h,Q2_5_h,Q2_6_h,Q2_7_h).

*The matching probability for the 10% ambiguity question (10 ball colors, win for 1 color).
COMPUTE Q2_est = (Q2_l_max + Q2_h_min)/2.

*The ambiguity aversion index for the 10% ambiguity question (10 ball colors, win for 1 color).
COMPUTE Q2_AA = 10 - Q2_est.


*Compute lower (_l) and upper (_h) bounds on the matching probability, based on the responses in 6 rounds
*Q3: data for ambiguity question with 10 ball colors and win for 9  colors (90%). 
*The original question was framed in terms of NOT winning for 1 ball color, and this influences the calculations. 

COMPUTE Q3_1_l = 0.
COMPUTE Q3_1_h = 100.

COMPUTE Q3_2_l = Q3_1_v*(Q3_1_b=1  | Q3_1_b=3) + Q3_1_l*(Q3_1_b=2).
COMPUTE Q3_2_h = Q3_1_v*(Q3_1_b=2  | Q3_1_b=3) + Q3_1_h*(Q3_1_b=1).

COMPUTE Q3_3_l = Q3_2_v*(Q3_2_b=1  | Q3_2_b=3) + Q3_2_l*(Q3_2_b=2).
COMPUTE Q3_3_h = Q3_2_v*(Q3_2_b=2  | Q3_2_b=3) + Q3_2_h*(Q3_2_b=1).

COMPUTE Q3_4_l = Q3_3_v*(Q3_3_b=1  | Q3_3_b=3) + Q3_3_l*(Q3_3_b=2).
COMPUTE Q3_4_h = Q3_3_v*(Q3_3_b=2  | Q3_3_b=3) + Q3_3_h*(Q3_3_b=1).

COMPUTE Q3_5_l = Q3_4_v*(Q3_4_b=1  | Q3_4_b=3) + Q3_4_l*(Q3_4_b=2).
COMPUTE Q3_5_h = Q3_4_v*(Q3_4_b=2  | Q3_4_b=3) + Q3_4_h*(Q3_4_b=1).

COMPUTE Q3_6_l = Q3_5_v*(Q3_5_b=1  | Q3_5_b=3) + Q3_5_l*(Q3_5_b=2).
COMPUTE Q3_6_h = Q3_5_v*(Q3_5_b=2  | Q3_5_b=3) + Q3_5_h*(Q3_5_b=1).

COMPUTE Q3_7_l = Q3_6_v*(Q3_6_b=1  | Q3_6_b=3) + Q3_6_l*(Q3_6_b=2).
COMPUTE Q3_7_h = Q3_6_v*(Q3_6_b=2  | Q3_6_b=3) + Q3_6_h*(Q3_6_b=1).

COMPUTE Q3_l_max = max(Q3_1_l,Q3_2_l,Q3_3_l,Q3_4_l,Q3_5_l,Q3_6_l,Q3_7_l).
COMPUTE Q3_h_min = min(Q3_1_h,Q3_2_h,Q3_3_h,Q3_4_h,Q3_5_h,Q3_6_h,Q3_7_h).


*The matching probability for the 90% ambiguity question, framed in terms of NOT winning for 1 out of 10 ball colors.
*It is better not to use this index, but rather Q3_EST_WIN, expressed in terms of winning for 9 out of 10 ball colors.
COMPUTE Q3_est = (Q3_l_max + Q3_h_min)/2.

*The matching probability for the 90% ambiguity question, expressed in terms of winning for 9 out of 10 ball colors.
COMPUTE Q3_est_win = 100 - Q3_est.

*The ambiguity avesion index for the 90% ambiguity question, expressed  in terms of winning for 9 out of 10 ball colors.
COMPUTE Q3_AA = 90 - Q3_est_win.


*An index for ambiguity-generate likelihood insensitivity (= AA90 - AA10). 
COMPUTE AA_Pr_insensitive_index = Q3_AA - Q2_AA.

