#!/usr/bin/perl -w

use CGI qw/:standard/;

################################################################################
## Define global parameters that apply to all iterations of the questions.
################################################################################					
$iteration_data = 6;
$number_tests = 3;			#number of initial tests
$iteration_cap = 6;
$sig_digs = 5;				#number of significant digits to round to
$random = 0;				# sets randomizer; 1=yes, 0=no

@color_chart;				#chart of colors to be used in graphs

$color_chart[0][0] = "800080";
$color_chart[0][1] = "Purple";
$color_chart[1][0] = "FFFF66";
$color_chart[1][1] = "Yellow";
$color_chart[2][0] = "FA8072";
$color_chart[2][1] = "Salmon";
$color_chart[3][0] = "BDB76B";
$color_chart[3][1] = "Khakhi";
$color_chart[4][0] = "008080";
$color_chart[4][1] = "Teal";
$color_chart[5][0] = "008000";
$color_chart[5][1] = "Green";
$color_chart[6][0] = "FFA500";
$color_chart[6][1] = "Orange";
$color_chart[7][0] = "87421F";
$color_chart[7][1] = "Brown";
$color_chart[8][0] = "0000FF";
$color_chart[8][1] = "Blue";
$color_chart[9][0] = "FF0000";
$color_chart[9][1] = "Red";
$color_chart[10][0] = "800000";
$color_chart[10][1] = "Maroon";

@default_color;				#default color definitions
$default_color[0] = "800080"; 
$default_color[1] = "800080"; 
$default_color[2] = "800080"; 
$default_color[3] = "800080"; 
$default_color[4] = "800080"; 
$default_color[5] = "800080"; 

################################################################################
# Check if all the tests are finished.
################################################################################
if (param('test_num') > $number_tests) {
	$iteration_cap = 1;
}
$convergence_val =2;
################################################################################
# Define all of the relevant parameters for all of the variants of the test.
################################################################################
@test = ();					#initialize array of tests#
$test[0] = {"risk_gain" => "1000", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "0",
		"risk_prob_gain" => 100*&get_prob(5), 		#set initial probability for selected color
		"title" => "Example Question: Choosing Between Two Boxes with Five Different Colors of Balls",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "-1",
		"color" => $default_color[0],
		"colors" => 5,				#number of colors to select from
		"tag_var" => "risk_prob_gain",
		"if_A" => "ceiling",
		"if_B" => "floor",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
We play the same game again, but with a different proportion of colored balls in Box K (see below).  Everything else is the same. 
<p>
You can choose between box U or box K, both containing 100 balls 
of five different colors. One ball will be drawn from the box you have chosen. 
You win &#36;1,000 if a <COLOR_ME> ball is drawn.
<p>
Please select the box of your choice: U or K. 
If you think both boxes are equally attractive, you can select Indifferent.
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of two different colors, the
	composition of colors will change as you make choices.  Box U has 100 colored balls, the composition 
	of these balls is fixed, but unknown.  A ball will be drawn at random from the box you select.  If the ball is the 
	same color as your winning color you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:
TEXTEND2
		"first_text" => <<"TEXTEND3",
In this game you can choose between box U or box K, both containing 100 balls of 5 different colors. One ball will be drawn from the box you have chosen. 
You win &#36;1,000 if a <COLOR_ME> ball is drawn.
<p>
For Box K you can see the exact proportion of colored balls below.
Box U also contains five different colors of balls, but the proportions are not shown in advance. 
Hence, both boxes contain 100 balls with the same five colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
<p>
Please select the box of your choice: U or K. 
If you think both boxes are equally attractive, select Indifferent.
<p>
TEXTEND3
};
$test[1] = {"risk_gain" => "1000", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "0",
		"risk_prob_gain" => 100*&get_prob(2), 		#set initial probability for selected color
		"title" => "Question 1: Choosing Between Two Boxes with Purple and Salmon Balls",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "1",
		"color" => $default_color[1],
		"colors" => 2,				#number of colors to select from
		"tag_var" => "risk_prob_gain",
		"if_A" => "ceiling",
		"if_B" => "floor",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
We play the same game again, but with a different proportion of purple and yellow balls in Box K (see below).  
Everything else is the same. 
<p>
You can choose between box U or box K, both containing 100 balls, 
which can be either purple or yellow. One ball will be drawn from the box you have chosen. 
You win &#36;1,000 if a <COLOR_ME> ball is drawn.
<p>
Please select the box of your choice: U or K. 
If you think both boxes are equally attractive, you can select Indifferent.
<p>
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of two different colors, the
	composition of colors will change as you make choices.  Box U has 100 colored balls, the composition 
	of these balls is fixed, but unknown.  A ball will be drawn at random from the box you select.  If the ball is the 
	same color as your winning color you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:<p>
TEXTEND2
		"first_text" => <<"TEXTEND3",
	In this game you can choose between box U or box K, both containing 100 balls, 
	which can be either purple or yellow. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of purple balls and yellow balls below.
	Box U also contains purple and yellow balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with two different colors (purple and yellow). The composition of purple 
	and yellow balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, you can select Indifferent.
	<p>
TEXTEND3
};
		
$test[2] = {"risk_gain" => "1000", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "0",
		"risk_prob_gain" => 100*&get_prob(10), 
		"title" => "Question 2: Choosing Between Two Boxes with 10 Different Colors",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "1",
		"color" => $default_color[2],
		"colors" => 10,
		"tag_var" => "risk_prob_gain",
		"if_A" => "ceiling",
		"if_B" => "floor",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
	We play the same game again, but with a different proportion of colored balls in Box K (see below).  Everything else is the same. 
	<p>
	You can choose between box U or box K, both containing 100 balls of 10 different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, you can select Indifferent.
	<p>
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of 10 different colors, the
	composition of colors will change as you make choices.  Box U has 100 colored balls of 10 different colors, the 
	composition of these balls is fixed but unknown.  A ball will be drawn at random from the box you select.  If the 
	ball is the same color as your winning color you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:
TEXTEND2
		"first_text" => <<"TEXTEND3",
	In this game you can choose between box U or box K, both containing 100 balls of 10 different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains 10 different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same 10 different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND3
};

$test[3] = {"risk_gain" => "0", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "1000",
		"risk_prob_gain" => 100*&get_prob(10), 
		"title" => "Question 3: Choosing Between Two Boxes with 10 Different Colors",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "1",
		"color" => $default_color[3],
		"colors" => 10,
		"tag_var" => "risk_prob_gain",
		"if_A" => "floor",
		"if_B" => "ceiling",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
	We play the same game again, but with a different proportion of colored balls in Box K (see below).  Everything else is the same. 
	<p>
	You can choose between box U or box K, both containing 100 balls of 10 different colors. One ball will be drawn from the box you have chosen. 
	If the ball drawn from the box is any color <b>OTHER</b> than <COLOR_ME> you win &#36;1,000.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, you can select Indifferent.
	<p>
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of 10 different colors, the
	composition of colors will change as you make choices.  Box U has 100 colored balls of 10 different colors, the 
	composition of these balls is fixed but unknown.  A ball will be drawn at random from the box you select.  If the 
	ball is any of your nine winning colors you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:
TEXTEND2
		"first_text" => <<"TEXTEND3",
	In this game you can choose between box U or box K, both containing 100 balls of 10 different colors. One ball will be drawn from the box you have chosen. 
	If the ball drawn from the box is any color <b>OTHER</b> than <COLOR_ME> you win &#36;1,000.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains 10 different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same 10 different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND3
};

################################################################################						
# set final questions
################################################################################
$test[4] = {"risk_gain" => "1000", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "0",
		"risk_prob_gain" => 100*&get_prob(2), 	#set initial probability for selected color
		"title" => "Question 4: Choosing Between Two Boxes with Two Different Colors",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "1",
		"color" => $default_color[4],
		"colors" => 2,				#number of colors to select from
		"tag_var" => "risk_prob_gain",
		"if_A" => "ceiling",
		"if_B" => "floor",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
	In this game you can choose between box U or box K, both containing 100 balls of two different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains two different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same two different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of two different colors.  Box U 
	also has 100 colored balls of two different colors, but the composition is unknown.  A ball will be drawn at random 
	from the box you select.  If the ball is the same color as your winning color you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:
TEXTEND2
		"first_text" => <<"TEXTEND3",
	In this game you can choose between box U or box K, both containing 100 balls of two different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains two different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same two different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND3
};

$test[5] = {"risk_gain" => "1,000", 			#each array element contains a hash table of name/value pairs with initial values#
		"risk_loss" => "0",
		"risk_prob_gain" => 100*&get_prob(2), 
		"title" => "Question 5: Choosing Between Two Boxes with Two Different Colors",
		"a_label" => "Choice U",
		"b_label" => "Choice K",
		"direction" => "Which option do you prefer?",
		"floor" => "0", 
		"ceiling" => "100",
		"iteration" => "1",
		"color" => $default_color[5],
		"colors" => 2,
		"tag_var" => "risk_prob_gain",
		"if_A" => "ceiling",
		"if_B" => "floor",
		"color_text" => <<"CTEXTEND",
	Note:  if you prefer a different winning color use the drop box.
CTEXTEND
		"text" => <<"TEXTEND",
	In this game you can choose between box U or box K, both containing 100 balls of two different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains two different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same two different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND
		"select_text" => <<"TEXTEND2",
	Please select between the two boxes displayed below.  Box K has 100 colored balls of two different colors.  Box U 
	also has 100 colored balls of two different colors, but the composition is unknown.  A ball will be drawn at random 
	from the box you select.  If the ball is the same color as your winning color you win &#36;1,000.<P> 
	 
	The payoffs and compositions are as follows:
TEXTEND2
		"first_text" => <<"TEXTEND3",
	In this game you can choose between box U or box K, both containing 100 balls of two different colors. One ball will be drawn from the box you have chosen. 
	You win &#36;1,000 if a <COLOR_ME> ball is drawn.
	<p>
	For Box K you can see the exact proportion of colored balls below.
	Box U also contains two different colors of balls, but the proportions are not shown in advance. 
	Hence, both boxes contain 100 balls with the same two different colors.  The composition of colored balls is known (K) for box K and unknown (U) for box U.
	<p>
	Please select the box of your choice: U or K. 
	If you think both boxes are equally attractive, select Indifferent.
	<p>
TEXTEND3
};

################################################################################
## Determine the color name to display in text
################################################################################
if (defined param('color_opt') && param('mode') eq "Select Color") {
	$color_in = translate_color(param('color_opt'));
	$test[param('test_num')]{'first_text'} =~ s/\<COLOR\_ME\>/$color_in/;
} elsif ((param('mode') eq "Indifferent") && defined param('test_num') && defined $default_color[param('test_num')+1]) {
	$color_in = translate_color($default_color[param('test_num')+1]);
	$test[param('test_num')+1]{'first_text'} =~ s/\<COLOR\_ME\>/$color_in/;
} elsif (defined param('color') && param('iteration') != -1 && calc_choice() != 0) {
	$color_in = translate_color(param('color'));
	$test[param('test_num')]{'text'} =~ s/\<COLOR\_ME\>/$color_in/;
} elsif (param('iteration') == -1) {
	$color_in = translate_color($default_color[0]);
	$test[0]{'first_text'} =~ s/\<COLOR\_ME\>/$color_in/;
} elsif (defined $default_color[param('test_num')+1]) {
	$color_in = translate_color($default_color[param('test_num')+1]);
	$test[param('test_num')+1]{'first_text'} =~ s/\<COLOR\_ME\>/$color_in/;
}

################################################################################
# Check if this is the first round.  If so, then post the first test.  If it is 
# not, then go to subroutine comp_choice to generate the correct testing values.
################################################################################
if (!defined param('mode')) {
	if (defined param('gender')) {
		$test[0]{'iteration'} = $test[0]{'iteration'}+2;
	}
	print_test(0);		 		#begin first test#
} else {
	comp_choice() 				#perform computation for selected value#
}

################################################################################
# Subroutine for computing new values.  This is the core of the program.  All
# of the work is either done here or controlled from this subroutine.
################################################################################
sub comp_choice {
if (param('mode') eq "Select Color") {		#set color selection
	$test[param('test_num')]{'color'} = param('color_opt');
	$test[param('test_num')]{'iteration'} = param('iteration')+1;
	print_test(param('test_num'));
} else {
if ((param('mode') eq "Indifferent") || (calc_choice() == 0)) { #if selection is indifferent or convergence is satisfied continue to next test#
	my $test_num = param('test_num')+1;	#increment test number#
	print_test($test_num); 			#initialize next test#
} 
elsif (param('mode') eq "Choice K") { 		#if choice K is selected update hash accordingly#
	$up_down = param($test[param('test_num')]{'if_B'});
	$test[param('test_num')]{$test[param('test_num')]{'tag_var'}} = ($up_down+param($test[param('test_num')]{'tag_var'}))/2;
	$test[param('test_num')]{$test[param('test_num')]{'if_A'}} = param($test[param('test_num')]{'tag_var'});
	$test[param('test_num')]{$test[param('test_num')]{'if_B'}} = param($test[param('test_num')]{'if_B'});
	$test[param('test_num')]{'iteration'} = param('iteration')+1;
	$test[param('test_num')]{'color'} = param('color');
	print_test(param('test_num'));
} else { 					#if choice U is selected update hash accordingly#
	$up_down = param($test[param('test_num')]{'if_A'});
	$test[param('test_num')]{$test[param('test_num')]{'if_A'}} = param($test[param('test_num')]{'if_A'});
	$test[param('test_num')]{$test[param('test_num')]{'tag_var'}} = ($up_down+param($test[param('test_num')]{'tag_var'}))/2;
	$test[param('test_num')]{$test[param('test_num')]{'if_B'}} = param($test[param('test_num')]{'tag_var'});
	$test[param('test_num')]{'iteration'} = param('iteration')+1;
	$test[param('test_num')]{'color'} = param('color');
	print_test(param('test_num'));
}
}
}

################################################################################
# This subroutine generates all of the html code to display questions and to
# interact with the subject.  This also is responsible for interacting with the
# hidden variables to retain information across iterations.
################################################################################
sub print_test {
	my $test_num = shift;				#get test number from function parameters#
	my $age = param('age');
	my $gender = param('gender');
	my $major = param('major');
if (!defined $test[$test_num]) {			#if the survey is complete
	extract_old($test_num-1, "store");		#store data into array#
	store_data($test_num-1);			#store data into database#
	print "Content-type: text/html\n\n";		#tell the server what the content is#
	print "Thank You!\n";
} else {
if(($test_num > $number_tests)) {			#move on to dynamic tests#
		extract_old($test_num-1, "store");	#store data into array#
		alpha_lambda();				#calculate parameters
		$test[$test_num]{'risk_prob_gain'} = $calculations[$test_num];	#set appropriate value
		}					#print the web form#
if (param('mode') eq 'Select Color') {
	$test[$test_num]{'iteration'} = 1;
	$test[$test_num]{'risk_prob_gain'} = param('risk_prob_gain');
}
if ($random == 1) {
	$rand_per = substr($test[$test_num]{'risk_prob_gain'}, 0, $sig_digs);
	$test[$test_num]{'color_text'} = "If you want to change the winning color, without affecting the probability of drawing a winning ball from box K (it will still be $rand_per\%), please choose an alternative color here.";
}
if ($test[$test_num]{'iteration'} != -1) {
	$title_print = $test[$test_num]{'title'};
} else {
	$title_print = "Preliminary Demographics Collection";
}
	print "Content-type: text/html\n\n";		#tell the server what the content is#	
print <<"FORMEND";		#include all text up to FORMEND line#
		<table><tr><td align=center>
		<div style="border-style: solid; width: 720px">
		<b>$title_print</b>
		</div></td></tr>
		<tr><td><div style="border-style: solid; width: 720px">
		<form name=survey method=post action="/cgi-bin/Survey_F_New_Color_3.pl">
		<input type=hidden name=test_num value=$test_num>
		<input type=hidden name=risk_prob_gain value=$test[$test_num]{'risk_prob_gain'}>
		<input type=hidden name=risk_gain value=$test[$test_num]{'risk_gain'}>
		<input type=hidden name=risk_loss value=$test[$test_num]{'risk_loss'}>
		<input type=hidden name=color value=$test[$test_num]{'color'}>
		<input type=hidden name=ceiling value=$test[$test_num]{'ceiling'}>
		<input type=hidden name=floor value=$test[$test_num]{'floor'}>
		<input type=hidden name=iteration value=$test[$test_num]{'iteration'}>
FORMEND
	if ($test[$test_num]{'iteration'} != -1) {
print <<"FORMEND";		#include all text up to FORMEND line#
		<input type=hidden name=age value=$age>
		<input type=hidden name=gender value=$gender>
		<input type=hidden name=major value=$major>
FORMEND
	}
if(($test_num > $number_tests) && $test[$test_num]{'iteration'}==1) {
	print "<input type=hidden name=iteration_cap value=1>\n";
}
		extract_old($test_num, "print");	#print out previous hidden data fields#
	my $mode = param('mode');
	my $tag_var = param($test[param('test_num')]{'tag_var'});
if($test[$test_num]{'iteration'} > 1) {		#if not initial round then store data in hidden field#
	my $val = $test[$test_num]{'iteration'}-1;
		print "<input type=hidden name=\"$test_num\.$val\" value=\"$test_num | $val | $tag_var | $mode\">\n";
} elsif ((param('iteration') == $iteration_cap) || (param('mode') eq "Indifferent") || (calc_choice() == 0) && ($test[$test_num]{'iteration'} != 0)) {		#if final iteration or indifferent then store last result before continuing#
	my $val = param('iteration');
	my $test_num_old = param('test_num');
		print "<input type=hidden name=\"$test_num_old\.$val\" value=\"$test_num_old | $val | $tag_var | $mode\">\n";
	}
		$percentages = get_percentages($test_num);
		$colors = get_colors($test_num);
		$values = get_values($test_num);
		$amb_percentages = get_amb_percentages($test_num);
		$amb_values = get_amb_values($test_num);
		$amb_colors = get_amb_colors($test_num);
		$told_color = tell_color($test_num);
		if ($test_num == 3) {
			$paren_text = "You win \$1,000 if any color <b>OTHER</b> than <font color=\"$told_color\">$told_color</font> ball is drawn";
		} else {
			$paren_text = "You win \$1,000 if a <font color=\"$told_color\">$told_color</font> ball is drawn";
		}
		
# demographics gathering
	if ($test[$test_num]{'iteration'} == -1) {
print <<"FORMEND";
		<br>
		<center>
		<table>
			<tr><th colspan=\"2\" align=\"center\">
				Demographic Information
			</th></tr>
			<tr><td align=\"left\">
				Age:
			</td><td align=\"left\"v>
				<input type=\"text\" name=\"age\">
			</td></tr>
			<tr><td align=\"left\">
				Gender:
			</td><td align=\"left\">
				<select name=\"gender\">
					<option value=\"female\">female</option>
					<option value=\"male\">male</option>
				</select>
			</td></tr>
			<tr><td align=\"left\">
				College Major:
			</td><td align=\"left\">
				<input type=\"text\" name=\"major\">
			</td></tr>
			<tr><td colspan=\"2\" align=\"center\">
				<input type=\"submit\" value=\"Begin Survey">
			</td></tr>
			<td>&nbsp;</td>
			</tr>
			<td>&nbsp;</td>
			</tr>
			<tr><td colspan=\"2\" align=\"left\">
			After submitting this demographic information you will see a practice
			question.  Following the practice question you will be asked five sets of
			questions.  For the first three sets of questions there will be multiple rounds.
			It will take approximately 10 minutes to complete the entire survey.
			</td></tr>
		</table>
		</center>
		<br>
FORMEND
	} elsif ($test[$test_num]{'iteration'} == 0) {
	## The very first screen of each set of questions.  This one asks the 
## respondent to select a color.

FORMEND
## The second set of questions.  This one asks the respondent to 
## make their first choice.  Because this is the first choice the 
## instructions are more detailed than in later rounds, but in general it is 
## very similar to the "else" statement later.
	} elsif ($test[$test_num]{'iteration'} == 1) {
		print <<"FORMEND";
		<table width=540 name=survey_table>
		<tr><td>$test[$test_num]{'first_text'}<br><br></td></tr>
		<tr><td align=center><table width=100%>
		<tr><td>$test[$test_num]{'a_label'}</td><td>$test[$test_num]{'b_label'}</td></tr>
		<tr>

		<td><img src=\"http\:\/\/chart.apis.google.com\/chart\?cht\=p3\&chd\=t\:$amb_percentages\&chs\=350x100\&chco=$amb_colors\&chl\=$amb_values\"></td>

		<td><img src=\"http\:\/\/chart.apis.google.com\/chart\?cht\=p3\&chd\=t\:$percentages\&chs\=350x100\&chco=$colors\&chl\=$values\"></td>
		
		</tr>
				
		<tr><td colspan=2 align=center>$test[$test_num]{'direction'} ($paren_text)</td></tr>
		<tr><td colspan=2><table width=100%>
		<tr><td align=center><input type=submit name=mode value="Choice U"></td>
			<td align=center><input type=submit name=mode value="Indifferent"></td>
			<td align=center><input type=submit name=mode value="Choice K"></td></tr>
			</table>
			<center>
				<table width=540 name=survey_table>
				<tr><td align=center><table width=100%>
				<tr>
						
		  	</tr>
				<tr><td colspan=2><table width=100%>
				<tr><td colspan=2><center>$test[$test_num]{'color_text'}</center></td></tr>
				<tr><td align=center colspan=2>
FORMEND
		get_color_choice($test_num);
		print <<"FORMEND";		
		</td></tr></table></center>
		</td></tr>
FORMEND
## This code controls all rounds after the first choice.
	} else {
print <<"FORMEND";
		<table width=540 name=survey_table>
		<tr><td>$test[$test_num]{'text'}<br><br></td></tr>
		<tr><td align=center><table width=100%>
		<tr><td>$test[$test_num]{'a_label'}</td><td>$test[$test_num]{'b_label'}</td></tr>
		<tr>

		<td><img src=\"http\:\/\/chart.apis.google.com\/chart\?cht\=p3\&chd\=t\:$amb_percentages\&chs\=350x100\&chco=$amb_colors\&chl\=$amb_values\"></td>

		<td><img src=\"http\:\/\/chart.apis.google.com\/chart\?cht\=p3\&chd\=t\:$percentages\&chs\=350x100\&chco=$colors\&chl\=$values\"></td>
		
		</tr>
				
		<tr><td colspan=2 align=center>$test[$test_num]{'direction'} ($paren_text)</td></tr>
		<tr><td colspan=2><table width=100%>
		<tr><td align=center><input type=submit name=mode value="Choice U"></td>
			<td align=center><input type=submit name=mode value="Indifferent"></td>
			<td align=center><input type=submit name=mode value="Choice K"></td></tr>
			</table></td></tr>
		</table></td></tr>
FORMEND
		}
print "</table></form></div>";
	}
}					
		

################################################################################
# This subroutine checks for convergence.
################################################################################
sub calc_choice {				#either "not initial AND covergent" OR "max iterations met"#
my $increment = 0;
if (param('mode') eq "Choice U") {			#conditionals for A or B#
$increment = param('ceiling');
} elsif (param('mode') eq "Choice K") {
$increment = param('floor');
}
if(((param('iteration') != 1) && (abs((param($test[param('test_num')]{'tag_var'}))-(($increment+param($test[param('test_num')]{'tag_var'}))/2)) <= $convergence_val)) || ((param('iteration')) >= $iteration_cap)) {
return 0;
} else {
return 1;
}
}

################################################################################						
# subroutine for sorting through data stored in the hidden variables and 
# extracting information from previous iterations.
################################################################################
sub extract_old {
my ($test_num, $function) = @_;
for(my $i=1;$i<=$test_num;$i++) {		#loop through each test#
for(my $j=1;$j<=$iteration_data;$j++) {		#loop through each iteration#
$look_for = $i.".".$j;
if(defined param($look_for)) {			#if stored data found then extract accordingly#
if($function eq "store") {
$round[$i][$j] = param($look_for);		#place data into array for later processing#
} elsif ($function eq "print") {
$value = param($look_for);
print "<input type=hidden name=\"$look_for\" value=\"$value\">\n";	#print out data fields#
}
}
}
}
}

################################################################################
# This subroutine writes data to the output file.
################################################################################
sub store_data {
my $test_num = shift;
my $age = param('age');
my $gender = param('gender');
my $major = param('major');
my $val = param('iteration');
my $tag_var = param($test[param('test_num')]{'tag_var'});
my $mode = param('mode');
my $user_id = localtime();				#ID according to precise time#
open(DATAFILE, ">>Survey_F.txt" || die "data death!");	#open data file for appending#
print DATAFILE "$user_id | $age | $gender | $major | -----\n";	#output demographics#
for(my $i=1;$i<=$test_num;$i++) {			#loop through each test#
for(my $j=1;$j<=$iteration_data;$j++) {			#loop through each iteration#
if (defined $round[$i][$j]) {				#if entry stored in array#
print DATAFILE "$user_id | $round[$i][$j]\n";		#output array data#
}
}
}	
print DATAFILE "$user_id | $test_num | $val | $tag_var | $mode\n";	#output most recent round#
print DATAFILE "----------------------------------------------\n";
close(DATAFILE);						#close file#
}

################################################################################						
# subroutine for setting percentage values on graphs
################################################################################
sub get_percentages {
my $test_num = shift;
$return_values = "";
my @p_values;
for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
$p_values[$k] = $color_chart[$k][0];
}
if($test[$test_num]{'iteration'} == 0) {
for ($i=0;$i<=($#p_values);$i++) {
$return_values .= eval(100/($#p_values+1)).",";
}
chop($return_values);
return $return_values;
} else {
for ($i=0;$i<=($#p_values);$i++) {
if ($i==0) {
$return_values .= $test[$test_num]{$test[$test_num]{'tag_var'}}.",";
} else {
$return_values .= (100-$test[$test_num]{$test[$test_num]{'tag_var'}})/($#p_values).",";
}
}
chop($return_values);
return $return_values;
}
}

################################################################################						
# subroutine for setting ambiguous percentage values on graphs
################################################################################
sub get_amb_percentages {
my $test_num = shift;
$return_values = "";
my @ap_values;
for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
$ap_values[$k] = $color_chart[$k][0];
}
for ($i=0;$i<=($#ap_values);$i++) {
$return_values .= eval(100/($#ap_values+1)).",";
}
chop($return_values);
return $return_values;
}

################################################################################						
# subroutine for setting color values on graphs
################################################################################
sub get_colors {
my $test_num = shift;
my @c_values;
for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
$c_values[$k] = $color_chart[$k][0];
}
$return_values = "";
for ($i=0;$i<=($#c_values);$i++) {
if (($c_values[$i] eq $test[$test_num]{'color'})) {
$return_values .= splice(@c_values, $i, 1)."|";
}
}
while ($#c_values >= 0) {
$return_values .= shift(@c_values)."|";
}
chop($return_values);
return $return_values;
}

################################################################################						
# subroutine for setting display values on graph
################################################################################
sub get_values {
my $test_num = shift;
if($test[$test_num]{'iteration'} == 0) {
	return;
} else {
	my @v_values;
	for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
		$v_values[$k] = $color_chart[$k][0];
	}
	$return_values = "";
	for ($i=0;$i<=($#v_values);$i++) {
		if ((defined $test[param('test_num')]{'color'}) && ($v_values[$i] eq $test[param('test_num')]{'color'})) {
			$reduced = substr($test[$test_num]{$test[$test_num]{'tag_var'}}, 0, $sig_digs);
			$return_values .= "\$$test[$test_num]{'risk_gain'}\%20\:\%20$reduced\%"."|";
			splice(@v_values, $i, 1);
		}
	}
	$leftover = ((100-$test[$test_num]{$test[$test_num]{'tag_var'}})/($#v_values+1));
	$leftover_reduced = substr($leftover, 0, $sig_digs);
	while ($#v_values >= 0) {
		$return_values .= "\$$test[$test_num]{'risk_loss'}\%20:\%20".$leftover_reduced."\%"."|";
		shift(@v_values);
	}
	chop($return_values);
	return $return_values;
}
}

################################################################################						
# subroutine for setting ambiguous display values on graph
################################################################################
sub get_amb_values {
my $test_num = shift;
my @av_values;
for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
$av_values[$k] = $color_chart[$k][0];
}
$return_values = "";
for ($i=0;$i<=($#av_values);$i++) {
if ((defined $test[param('test_num')]{'color'}) && ($av_values[$i] eq $test[param('test_num')]{'color'})) {
$return_values .= "\$$test[$test_num]{'risk_gain'}\%20\:\%20\?\%"."|";
splice(@av_values, $i, 1);
}
}
while ($#av_values >= 0) {
$return_values .= "\$$test[$test_num]{'risk_loss'}\%20:\%20\?\%"."|";
shift(@av_values);
}
chop($return_values);
return $return_values;
}

################################################################################						
# subroutine for setting ambiguous color values on graph
################################################################################
sub get_amb_colors {
my $test_num = shift;
my @ac_values;
for ($k=0;$k<($test[$test_num]{'colors'});$k++) {
$ac_values[$k] = $color_chart[$k][0];
}
$return_values = "";
while ($#ac_values >= 0) {
$return_values .= "808080"."|";
shift(@ac_values);
}
chop($return_values);
return $return_values;
}

################################################################################						
# subroutine for displaying the color selection menu
################################################################################
sub get_color_choice {
my $test_num = shift;
print <<"SCRIPTEND";\
<script>
function color_switch() {
document.getElementById('color_opt').style.backgroundColor = '#'+document.getElementById('color_opt').value;
}
</script>
SCRIPTEND
print "<select id=color_opt style='background: \#$color_chart[0][0]' onchange='color_switch()' name=color_opt>";
for ($i=0;$i<($test[$test_num]{'colors'});$i++) {
if ($i==0) {
print "<option selected style='background: \#$color_chart[$i][0]' value=$color_chart[$i][0]>$color_chart[$i][1]</option>";
} else {
print "<option style='background: \#$color_chart[$i][0]' value=$color_chart[$i][0]>$color_chart[$i][1]</option>";
}
}
print "</select><input type=submit name=mode value='Select Color'>";
}

################################################################################						
# subroutine for retreiving selected color value by name
################################################################################
sub tell_color {
my $test_num = shift;
for ($i=0;$i<($test[$test_num]{'colors'});$i++) {
if ($test[$test_num]{'color'} eq $color_chart[$i][0]) {
$charted_color = $color_chart[$i][1];
}
}
return $charted_color;
}

################################################################################						
# subroutine for retreiving selected color value by hexadecimal value
################################################################################
sub translate_color {
my $hex_val = shift;
for ($i=0;$i<($#color_chart);$i++) {
	if ($hex_val eq $color_chart[$i][0]) {
		$charted_color = $color_chart[$i][1];
	}
}
return $charted_color;
}

################################################################################						
# subroutine for calculating parameter values
################################################################################
sub alpha_lambda {
$test_num = $number_tests;
my $i=1;
for(my $j=1;$j<=$iteration_data;$j++) {			#loop through each iteration#
if ((defined $round[$i][$j]) && (!$round[$i][$j+1])) {
	 my ($one, $two, $tag, $four) = ($round[$i][$j] =~ /(^.+\|)(.+\|.)(.+)(.\|.+$)/);
	 my ($one_l, $two_l, $tag_l, $four_l) = ($round[$i][$j-1] =~ /(^.+\|)(.+\|.)(.+)(.\|.+$)/);
	 if ($four=~m/Indifferent/ || $four eq $four_l){
	 		$alpha =$tag;
	 }else{
	 		$alpha=($tag+$tag_l)/2;
	 }
}
}
@calculations;						#set calculations for final questions
$calculations[4] = $alpha*1.2;
$calculations[5] = $alpha*0.8;
}
################################################################################
# Set initial probabilities
################################################################################
sub get_prob {
$color_num = shift;
	if (!$random) {
		return (1/$color_num);
	} else {
		return rand;
	}
}